package edu.sjsu.rhinofaces;

import java.util.logging.Logger;

import javax.faces.application.NavigationHandler;
import javax.faces.application.ViewHandler;
import javax.faces.component.UIViewRoot;
import javax.faces.context.FacesContext;

public class RhinoNavigationHandler extends NavigationHandler {

    private static Logger logger = Logger.global;
    
    private NavigationHandler delegate;
    
    public RhinoNavigationHandler(NavigationHandler delegate) {
        super();
        this.delegate = delegate;
    }
    
    public void handleNavigation(FacesContext context, String fromAction, String outcome) {
        if (context != null) {
            UIViewRoot oldRoot = context.getViewRoot();
            if (oldRoot != null) logger.info("Old root: " + oldRoot.getViewId());
            
            UIViewRoot newRoot = context.getApplication().getViewHandler().createView(context, "/" + outcome + ".jsp");
            context.setViewRoot(newRoot);
            
            logger.info("New root: " + context.getViewRoot().getViewId());
        }
        
        delegate.handleNavigation(context, fromAction, outcome);
        
        //ViewHandler viewHandler = null;
        //UIViewRoot newRoot = viewHandler.createView(context, outcome);
        //context.setViewRoot(newRoot);
    }

}